
#include "pmacros.h"
#include "system.h"

#include <stdio.h>
#include <sched.h>
#include <stdlib.h>
#include <string.h>
#include <semaphore.h>
#include <errno.h>

#include "spmd.h"
#include "returncode.h"



void compute(int size_input, int* data_input, int size_output, int* data_output)
{
  int result=0;
  int* id=data_input;
  for (int i=0;i<size_input;i++) {
	  if (*id>result)
	     result=*id;
          id++;
  }
   
  *data_output=result;
  printf("Thread %x gets %d\n",pthread_self(), result); 
}


void* POSIX_Init(void *argument)
{
 int  status;
 int  input[10] = {6,9,3,  10,30,4,  100,5,8,0};
 int* output = NULL;
 int  result=0;

 pthread_spmd_attr_t attr;
 pthread_spmd_t      s;

 pthread_spmd_attr_init(&attr);
 pthread_spmd_attr_setpriority(&attr, 100);
 pthread_spmd_attr_setsize(&attr, 3);

 status=pthread_spmd_init(&s, attr);
 if(status!=0)
     returncode("pthread_spmd_init init.c",status);

 status=pthread_spmd_scatter(&s, compute, input, 10, 1);
 if(status!=0)
     returncode("pthread_spmd_scatter init.c",status);

 output=(int*)pthread_spmd_gather(&s);
 if(output==NULL)
     returncode("pthread_spmd_gather init.c",status);
 for(int i=0;i<3;i++) {
     if(*output>result)
         result=*output;
     output++;
 }
 printf("init.c thread %x gets %d\n",pthread_self(), result);

 pthread_spmd_destroy(&s);
 printf("init.c is completed\n");
 pthread_exit(NULL);
 return 0; 
}



