
#include <sched.h>
#include <semaphore.h>

#ifndef  SCATTER_GATHER_H		
#define  SCATTER_GATHER_H  yes

#define CONFIGURE_SCATTER_GATHER_SIZE 10



typedef void (*comp_t) (int size_input, int* data_input, int size_output, int* data_output);


typedef struct pthread_spmd_attr_t {
  int priority;
  int size;
} pthread_spmd_attr_t;




typedef struct pthread_spmd_t{
  comp_t  func_compute;
} pthread_spmd_t;




extern int pthread_spmd_attr_init(struct pthread_spmd_attr_t *a);
extern int pthread_spmd_attr_setpriority(struct pthread_spmd_attr_t *a, int prio);
extern int pthread_spmd_attr_getpriority(struct pthread_spmd_attr_t a);
extern int pthread_spmd_attr_setsize(struct pthread_spmd_attr_t *a, int s);
extern int pthread_spmd_attr_getsize(struct pthread_spmd_attr_t a);
extern int pthread_spmd_attr_destroy(struct pthread_spmd_attr_t *a);


extern int   pthread_spmd_init(struct pthread_spmd_t* s, struct pthread_spmd_attr_t a);
extern int   pthread_spmd_scatter(struct pthread_spmd_t* s, comp_t f, int* data_input, int  size_input, int size_output);
extern void* pthread_spmd_gather (struct pthread_spmd_t* s);
extern int   pthread_spmd_status (struct pthread_spmd_t* s);
extern int   pthread_spmd_destroy(struct pthread_spmd_t* s);



#endif				


